



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spring+springmvc+hibernate 整合</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spring+springmvc+hibernate 整合</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 18:20:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>三大框架反反复复搭了很多次，虽然每次都能搭起来，但是效率不高。最近重新搭了一次，理顺了思路，整理了需要注意的地方，分享出来。</p>
<p><strong>工具：Eclipse（jdk 1.7） spring和hibernate版本均为4.0以上</strong></p>
<p>推荐使用maven构建项目，相比自己手动导入jar包要方便很多。</p>
<h3>1.新建一个maven web项目。（没用过maven的可以i先去了解一下）</h3>
<p><strong>注意点</strong>：使用Eclipse创建的maven工程文件结构可能不太正确，需要自己手动创建文件夹。</p>
<p>正确的文件结构：<br />-src</p>
<p>---main</p>
<p>------java（class文件）</p>
<p>------resources（配置文件）</p>
<p>------webapp（web文件）</p>
<p>---test（测试文件）</p>
<p>------java</p>
<p>------resources</p>
<h3>2.pom文件，导入jar包</h3>
<p>导入jar包也是框架整合中比较麻烦的点，常常会导入太多不相关的包，但由于不熟悉又不敢删掉，于是jar</p>
<p>包越导越多，到最后框架是搭起来，但jar包却导了十几二十个。</p>
<p><strong>注意点</strong>：这里建议的做法是当你不熟悉框架需要导入什么jar包时，可以先导入核心包，然后当运行项目时提示NotFoundClass时，再根据错误提示添加相关的依赖，这样就不会导入多余的jar包。</p>
<p>推荐可以到该网站上去搜索你需要的依赖：<a href="https://mvnrepository.com/" rel="external nofollow noreferrer">https://mvnrepository.com/</a></p>
<p>pom文件：</p>
<div>
<pre class="prettyprint linenums"> &lt;project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
   xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd"&gt;<br />
   &lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;<br />
   &lt;groupId&gt;hcoding&lt;/groupId&gt;<br />
   &lt;artifactId&gt;MyWebDemo&lt;/artifactId&gt;<br />
   &lt;packaging&gt;war&lt;/packaging&gt;<br />
   &lt;version&gt;0.0.1-SNAPSHOT&lt;/version&gt;<br />
   &lt;name&gt;MyWebDemo Maven Webapp&lt;/name&gt;<br />
   &lt;url&gt;http://maven.apache.org&lt;/url&gt;

   &lt;dependencies&gt;<br />
     &lt;dependency&gt;<br />
       &lt;groupId&gt;junit&lt;/groupId&gt;<br />
       &lt;artifactId&gt;junit&lt;/artifactId&gt;<br />
       &lt;version&gt;3.8.1&lt;/version&gt;<br />
       &lt;scope&gt;test&lt;/scope&gt;<br />
     &lt;/dependency&gt;

     &lt;!-- spring start --&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-context&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-core&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-beans&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-web&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-aspects&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-orm&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;!-- spring end --&gt;

     &lt;!-- springmvc start --&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
         &lt;artifactId&gt;spring-webmvc&lt;/artifactId&gt;<br />
         &lt;version&gt;4.3.9.RELEASE&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;!-- springmvc end --&gt;

     &lt;!-- loging start --&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
         &lt;artifactId&gt;slf4j-api&lt;/artifactId&gt;<br />
         &lt;version&gt;1.7.6&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;!-- loging end --&gt;

     &lt;dependency&gt;<br />
         &lt;groupId&gt;aspectj&lt;/groupId&gt;<br />
         &lt;artifactId&gt;aspectjrt&lt;/artifactId&gt;<br />
         &lt;version&gt;1.5.3&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.aspectj&lt;/groupId&gt;<br />
         &lt;artifactId&gt;aspectjtools&lt;/artifactId&gt;<br />
         &lt;version&gt;1.8.7&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;javax.servlet&lt;/groupId&gt;<br />
         &lt;artifactId&gt;jstl&lt;/artifactId&gt;<br />
         &lt;version&gt;1.2&lt;/version&gt;<br />
         &lt;scope&gt;runtime&lt;/scope&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;javax.annotation&lt;/groupId&gt;<br />
         &lt;artifactId&gt;javax.annotation-api&lt;/artifactId&gt;<br />
         &lt;version&gt;1.2&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;javax.servlet&lt;/groupId&gt;<br />
         &lt;artifactId&gt;servlet-api&lt;/artifactId&gt;<br />
         &lt;version&gt;2.5&lt;/version&gt;<br />
     &lt;/dependency&gt;

     &lt;!-- hibernate start --&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;org.hibernate&lt;/groupId&gt;<br />
         &lt;artifactId&gt;hibernate-core&lt;/artifactId&gt;<br />
         &lt;version&gt;4.2.3.Final&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;!-- hibernate end --&gt;

     &lt;!--c3p0 start --&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;c3p0&lt;/groupId&gt;<br />
         &lt;artifactId&gt;c3p0&lt;/artifactId&gt;<br />
         &lt;version&gt;0.9.1.2&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;!-- c3p0 end --&gt;

     &lt;!-- mysql start--&gt;<br />
     &lt;dependency&gt;<br />
         &lt;groupId&gt;mysql&lt;/groupId&gt;<br />
         &lt;artifactId&gt;mysql-connector-java&lt;/artifactId&gt;<br />
         &lt;version&gt;5.1.35&lt;/version&gt;<br />
     &lt;/dependency&gt;<br />
     &lt;!-- mysql end--&gt;<br />
   &lt;/dependencies&gt;<br />
     &lt;build&gt;<br />
         &lt;finalName&gt;MyWebDemo&lt;/finalName&gt;<br />
     &lt;/build&gt;<br />
 &lt;/project&gt;</pre>
</div>
<p>其中，注释块 &lt;spring&gt;&nbsp; &lt;springmvc&gt; &lt;hibernate&gt;中的依赖导入了框架核心jar包，我们可以提前导入，其他的我们可以根据提示或者需求进行改动。</p>
<p>比如，我的项目中使用的是mysql数据库和c3p0数据源，所以引入MySQL和c3p0的依赖，如果你使用的是其他数据库和数据源就需要做相应的修改。</p>
<p>pom文件中为注释的部分则是在项目运行时提示的jar包缺失引入的依赖，有的是spring框架依赖的包，有的则是servlet或者jsp依赖的，如果第一次搭建时不熟悉可以先不导入，等报错时再引入依赖，这样也可以加深理解。</p>
<div>&nbsp;</div>
<h3>3.配置文件</h3>
<div>这是框架整合最重要的部分。配置文件除了web.xml之外都放在main/resources文件夹中，当然你也可以放在其他自己新建的文件夹下，不过配置文件地址要做相应的修改，这个等会详细说。</div>
<div>配置文件的配置，很多框架整合的教程都不太一样的，这里给出我自己的配置方法和做法。</div>
<div>配置文件主要分为四个：web.xm , beans.xml , spring-mvc.xml , datasource.xml 。</div>
<div>配置步骤分为两步，spring-mvc和spring的整合，hibernate和spring的整合，最后再运行项目。（这也是效率比较高的做法，分开整合，这样即使运行项目有报错也比较好找，而且分部整合不容易乱）</div>
<div>接下来就开始具体配置。</div>
<div>&nbsp;</div>
<h3>4.spring-mvc和spring整合</h3>
<div>这是spring-mvc.xml配置文件：</div>
<div>
<div>
<pre class="prettyprint linenums"> &lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
        xmlns:context="http://www.springframework.org/schema/context"<br />
        xmlns:mvc="http://www.springframework.org/schema/mvc"<br />
        xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
         http://www.springframework.org/schema/beans/spring-beans-4.1.xsd<br />
         http://www.springframework.org/schema/context<br />
         http://www.springframework.org/schema/context/spring-context-4.1.xsd<br />
         http://www.springframework.org/schema/mvc<br />
         http://www.springframework.org/schema/mvc/spring-mvc-4.1.xsd"&gt;

     &lt;mvc:annotation-driven /&gt;

     &lt;context:component-scan base-package="com.hcoding.demo" &gt;<br />
         &lt;context:include-filter type="annotation"<br />
             expression="org.springframework.stereotype.Controller" /&gt;<br />
         &lt;!-- 排除@service注解的类 --&gt;<br />
         &lt;context:exclude-filter type="annotation"<br />
             expression="org.springframework.stereotype.Service" /&gt;<br />
     &lt;/context:component-scan&gt;

     &lt;!-- 对模型视图名称的解析,在请求时模型视图名称添加前后缀 --&gt;<br />
     &lt;bean id="viewResolver" class="org.springframework.web.servlet.view.InternalResourceViewResolver"&gt;<br />
         &lt;property name="viewClass" value="org.springframework.web.servlet.view.JstlView" /&gt;<br />
         &lt;property name="prefix" value="demo/" /&gt; &lt;!-- 前缀 --&gt;<br />
         &lt;property name="suffix" value=".jsp" /&gt;   &lt;!-- 后缀 --&gt;<br />
     &lt;/bean&gt;

     &lt;!-- 对静态资源的映射--&gt;<br />
     &lt;mvc:resources mapping="/js/**" location="/resources/js/" /&gt;<br />
     &lt;mvc:resources mapping="/css/**" location="/resources/css/" /&gt;<br />
     &lt;mvc:resources mapping="/img/**" location="/resources/img/" /&gt;

 &lt;/beans&gt;</pre>
</div>
<p>这是spring-mvc基本的配置，主要是对请求和静态资源映射的配置。</p>
<p><strong>&nbsp;注意点</strong>：1.需要特别注意的是扫描包时要排除service层的类，不然在整合hibernate后，项目运行时会报错。</p>
<p>具体原因看一下这个网址：<a href="http://blog.csdn.net/xiaobao5214/article/details/52042041" rel="external nofollow noreferrer">http://blog.csdn.net/xiaobao5214/article/details/52042041</a></p>
</div>
<p>2.然后就是如果你的包名和结构不一样的，那么扫描的包地址也要记得更换。</p>
<p>然后是web.xml配置文件：</p>
<div>
<pre class="prettyprint linenums"> &lt;!DOCTYPE web-app PUBLIC<br />
  "-//Sun Microsystems, Inc.//DTD Web Application 2.3//EN"<br />
  "http://java.sun.com/dtd/web-app_2_3.dtd" &gt;

 &lt;web-app&gt;<br />
   &lt;display-name&gt;MyWebDemo&lt;/display-name&gt;

     &lt;!-- 统一编码 解决中文乱码问题--&gt;<br />
     &lt;filter&gt;<br />
         &lt;filter-name&gt;charsetEncoding&lt;/filter-name&gt;<br />
         &lt;filter-class&gt;org.springframework.web.filter.CharacterEncodingFilter&lt;/filter-class&gt;<br />
         &lt;init-param&gt;<br />
             &lt;param-name&gt;encoding&lt;/param-name&gt;<br />
             &lt;param-value&gt;UTF-8&lt;/param-value&gt;<br />
         &lt;/init-param&gt;<br />
         &lt;init-param&gt;<br />
             &lt;param-name&gt;forceEncoding&lt;/param-name&gt;<br />
             &lt;param-value&gt;true&lt;/param-value&gt;<br />
         &lt;/init-param&gt;<br />
     &lt;/filter&gt;<br />
     &lt;filter-mapping&gt;<br />
         &lt;filter-name&gt;charsetEncoding&lt;/filter-name&gt;<br />
         &lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br />
     &lt;/filter-mapping&gt;

     &lt;!-- spring MVC 配置--&gt;<br />
     &lt;servlet&gt;<br />
          &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
          &lt;servlet-class&gt;org.springframework.web.servlet.DispatcherServlet&lt;/servlet-class&gt;<br />
          &lt;init-param&gt;<br />
             &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
             &lt;!-- 此处指向的的是SpringMVC的配置文件 如果配置文件地址和名称不一样需要更改--&gt;<br />
             &lt;param-value&gt;classpath:spring-mvc.xml&lt;/param-value&gt;<br />
          &lt;/init-param&gt;<br />
          &lt;!--配置容器在启动的时候就加载这个servlet并实例化--&gt;<br />
          &lt;load-on-startup&gt;1&lt;/load-on-startup&gt;<br />
     &lt;/servlet&gt;

     &lt;servlet-mapping&gt;<br />
         &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
         &lt;url-pattern&gt;/&lt;/url-pattern&gt;<br />
     &lt;/servlet-mapping&gt;<br />
     &lt;!-- spring MVC config end--&gt;

 &lt;/web-app&gt;</pre>
</div>
<p>将spring-mvc配置文件加到web.xml中，当服务器启动项目时，才会加载springmvc。配置完成后写个例子测试一下。</p>
<p>此时的项目结构：</p>
<p>-src</p>
<p>---main</p>
<p>------java（class文件）</p>
<p>----------com.hcoding.controller</p>
<p>----------com.hcoding.service</p>
<p>----------com.hcoding.dao</p>
<p>----------com.hcoding.model</p>
<p>------resources（配置文件）</p>
<p>----------spring-mvc.xml</p>
<p>------webapp（web文件）</p>
<p>----------demo（jsp文件）</p>
<p>----------resources（静态资源文件：css，js，img）</p>
<p>----------WEB-INF （web相关配置文件）</p>
<p>先在controller包中创建DemoController,class：</p>
<div>
<pre class="prettyprint linenums"> package com.hcoding.demo.controller;

 import java.util.HashMap;<br />
 import java.util.Map;<br />
 import java.util.concurrent.TimeUnit;

 import javax.annotation.Resource;<br />
 import javax.servlet.http.HttpServletRequest;

 import org.springframework.stereotype.Controller;<br />
 import org.springframework.web.bind.annotation.RequestMapping;<br />
 import org.springframework.web.servlet.ModelAndView;

 import com.alibaba.fastjson.JSON;<br />
 import com.hcoding.demo.model.People;<br />
 import com.hcoding.demo.service.DemoService;

 @Controller<br />
 public class DemoController{

     @RequestMapping("/test")<br />
     public String test(){<br />
         return "test";<br />
     }<br />
 }</pre>
</div>
<p>然后在demo文件夹中创建demo.jsp：</p>
<div>
<pre class="prettyprint linenums"> &lt;%@ page language="java" contentType="text/html; UTF-8"<br />
     pageEncoding="UTF-8"%&gt;<br />
 &lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&gt;<br />
 &lt;html&gt;<br />
 &lt;head&gt;<br />
 &lt;meta http-equiv="Content-Type" content="text/html; charset=utf-8"&gt;<br />
 &lt;title&gt;Insert title here&lt;/title&gt;<br />
 &lt;/head&gt;<br />
 &lt;body&gt;<br />
 &lt;p&gt;这是测试页面。&lt;/p&gt;<br />
 &lt;/html&gt;</pre>
</div>
<p>启动项目，在浏览器中输入地址：http://localhost:8080/（项目名）/test&nbsp; 。成功可以看到页面。</p>
<h3>5.spring和hibernate整合</h3>
<p>datasource.xml配置文件：</p>
<div>
<pre class="prettyprint linenums"> &lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
 &lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
     xmlns:jee="http://www.springframework.org/schema/jee"<br />
     xmlns:tx="http://www.springframework.org/schema/tx"<br />
     xmlns:context="http://www.springframework.org/schema/context"<br />
     xmlns:aop="http://www.springframework.org/schema/aop"<br />
     xsi:schemaLocation="<br />
     http://www.springframework.org/schema/aop<br />
     http://www.springframework.org/schema/aop/spring-aop-3.2.xsd<br />
     http://www.springframework.org/schema/beans<br />
     http://www.springframework.org/schema/beans/spring-beans-3.2.xsd<br />
     http://www.springframework.org/schema/tx<br />
     http://www.springframework.org/schema/tx/spring-tx-3.2.xsd<br />
     http://www.springframework.org/schema/jee<br />
     http://www.springframework.org/schema/jee/spring-jee-3.2.xsd<br />
     http://www.springframework.org/schema/context<br />
     http://www.springframework.org/schema/context/spring-context-3.2.xsd"&gt;

     &lt;!--配置数据源 这里是使用的是c3p0连接池--&gt;<br />
     &lt;bean id="dataSource" class="com.mchange.v2.c3p0.ComboPooledDataSource" destroy-method="close"&gt;<br />
         &lt;property name="driverClass" value="${jdbc.driver}" /&gt;  &lt;!--数据库连接驱动--&gt;<br />
         &lt;property name="jdbcUrl" value="${jdbc.url}" /&gt;     &lt;!--数据库地址--&gt;<br />
         &lt;property name="user" value="${jdbc.username}" /&gt;   &lt;!--用户名--&gt;<br />
         &lt;property name="password" value="${jdbc.password}" /&gt;   &lt;!--密码--&gt;<br />
         &lt;property name="maxPoolSize" value="40" /&gt;      &lt;!--最大连接数--&gt;<br />
         &lt;property name="minPoolSize" value="1" /&gt;       &lt;!--最小连接数--&gt;<br />
         &lt;property name="initialPoolSize" value="10" /&gt;      &lt;!--初始化连接池内的数据库连接--&gt;<br />
         &lt;property name="maxIdleTime" value="20" /&gt;  &lt;!--最大空闲时间--&gt;<br />
     &lt;/bean&gt;

     &lt;!--配置session工厂--&gt;<br />
     &lt;bean id="sessionFactory" class="org.springframework.orm.hibernate4.LocalSessionFactoryBean"&gt;<br />
         &lt;property name="dataSource" ref="dataSource" /&gt;<br />
         &lt;property name="packagesToScan" value="com.hcoding.demo" /&gt;<br />
         &lt;property name="hibernateProperties"&gt;<br />
             &lt;props&gt;<br />                 &lt;prop key="hibernate.hbm2ddl.auto"&gt;${hibernate.hbm2ddl.auto}&lt;/prop&gt; &lt;!--hibernate根据实体自动生成数据库表--&gt;<br />
                 &lt;prop key="hibernate.dialect"&gt;${hibernate.dialect}&lt;/prop&gt;   &lt;!--指定数据库方言--&gt;<br />
                 &lt;prop key="hibernate.show_sql"&gt;${hibernate.show_sql}&lt;/prop&gt;     &lt;!--在控制台显示执行的数据库操作语句--&gt;<br />
                 &lt;prop key="hibernate.format_sql"&gt;${hibernate.format_sql}&lt;/prop&gt;     &lt;!--在控制台显示执行的数据哭操作语句（格式）--&gt;<br />
             &lt;/props&gt;<br />
         &lt;/property&gt;<br />
     &lt;/bean&gt;

     &lt;!-- 事务配置 声明式事务--&gt;<br />
     &lt;bean id="transactionManager"<br />
         class="org.springframework.orm.hibernate4.HibernateTransactionManager"&gt;<br />
         &lt;property name="sessionFactory" ref="sessionFactory" /&gt;<br />
     &lt;/bean&gt;<br />
     &lt;!-- 使用annotation定义事务 --&gt;<br />
     &lt;tx:annotation-driven transaction-manager="transactionManager"/&gt;<br />
 &lt;/beans&gt;</pre>
</div>
<p>datasource.properties文件：</p>
<div>
<pre class="prettyprint linenums"> #database connection config<br />
 jdbc.driver = com.mysql.jdbc.Driver<br />
 jdbc.url = jdbc:mysql://localhost:3306/demo?useUnicode=true&amp;characterEncoding=utf-8<br />
 jdbc.username = root<br />
 jdbc.password = 123456

 #hibernate config<br />
 hibernate.dialect = org.hibernate.dialect.MySQLDialect<br />
 hibernate.show_sql = true<br />
 hibernate.format_sql = true<br />
 hibernate.hbm2ddl.auto = update</pre>
</div>
<p>beans.xml文件：</p>
<div>
<pre class="prettyprint linenums"> &lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
 &lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:context="http://www.springframework.org/schema/context"<br />
     xmlns:p="http://www.springframework.org/schema/p" xmlns:cache="http://www.springframework.org/schema/cache"<br />
     xsi:schemaLocation="<br />
         http://www.springframework.org/schema/beans<br />
         http://www.springframework.org/schema/beans/spring-beans-3.0.xsd<br />
         http://www.springframework.org/schema/context<br />
         http://www.springframework.org/schema/context/spring-context-3.0.xsd<br />
         http://www.springframework.org/schema/cache<br />
         http://www.springframework.org/schema/cache/spring-cache-3.1.xsd"&gt;

     &lt;!-- 注解 --&gt;<br />
     &lt;context:annotation-config /&gt;<br />
     &lt;!--扫描--&gt;<br />
     &lt;context:component-scan base-package="com.hcoding.demo"&gt;<br />
         &lt;context:exclude-filter type="annotation"<br />
             expression="org.springframework.stereotype.Controller" /&gt;<br />
     &lt;/context:component-scan&gt;

     &lt;!-- 导入多个Properties配置文件 --&gt;<br />
     &lt;bean id="propertyConfigurer" class="org.springframework.beans.factory.config.PropertyPlaceholderConfigurer"&gt;<br />
         &lt;property name="locations"&gt;<br />
             &lt;list&gt;<br />
                 &lt;!--要是有多个配置文件，只需在这里继续添加即可 --&gt;<br />
                 &lt;value&gt;classpath:datasource.properties&lt;/value&gt;<br />
             &lt;/list&gt;<br />
         &lt;/property&gt;<br />
     &lt;/bean&gt;<br />
30<br />     &lt;!-- 加载数据源组件 --&gt;        <br />     &lt;import resource="classpath:datasource.xml" /&gt;

 &lt;/beans&gt;</pre>
</div>
<p><strong>注意点</strong>：在xml导入properties文件是比较常见，将一些相关的配置数据写到properyties文件中也是常用的方法，利于修改。</p>
<p>常见的另一种导入propertise的方法：在&lt;context:property-placeholder location="classpath:/datasource.properties" /&gt;。这种方法spring默认值只导入一个properties，</p>
<p>当有多个properties文件需要导入时，则需要使用另一种方法：</p>
<div>
<pre class="prettyprint linenums">     &lt;!-- 导入多个Properties配置文件 --&gt;<br />
     &lt;bean id="propertyConfigurer" class="org.springframework.beans.factory.config.PropertyPlaceholderConfigurer"&gt;<br />
         &lt;property name="locations"&gt;<br />
             &lt;list&gt;<br />
                 &lt;!--要是有多个配置文件，只需在这里继续添加即可 --&gt;<br />
                 &lt;value&gt;classpath:datasource.properties&lt;/value&gt;<br />
                 &lt;value&gt;classpath:redis.properties&lt;/value&gt;<br />
             &lt;/list&gt;<br />
         &lt;/property&gt;<br />
     &lt;/bean&gt;</pre>
</div>
<p>个人比较推荐这种，随着项目扩展，需要导入的配置增多，肯定不止一个properties文件，这种方法更通用。</p>
<p><strong>&nbsp;注意点</strong>：datasource.properties文件中的数据库地址，用户和密码根据自己的情况做相应的修改。</p>
<p>修改之前的web.xml文件：</p>
<div>
<pre class="prettyprint linenums"> &lt;!DOCTYPE web-app PUBLIC<br />
  "-//Sun Microsystems, Inc.//DTD Web Application 2.3//EN"<br />
  "http://java.sun.com/dtd/web-app_2_3.dtd" &gt;

 &lt;web-app&gt;<br />
   &lt;display-name&gt;MyWebDemo&lt;/display-name&gt;

     &lt;!-- 统一编码 解决中文乱码问题--&gt;<br />
     &lt;filter&gt;<br />
         &lt;filter-name&gt;charsetEncoding&lt;/filter-name&gt;<br />
         &lt;filter-class&gt;org.springframework.web.filter.CharacterEncodingFilter&lt;/filter-class&gt;<br />
         &lt;init-param&gt;<br />
             &lt;param-name&gt;encoding&lt;/param-name&gt;<br />
             &lt;param-value&gt;UTF-8&lt;/param-value&gt;<br />
         &lt;/init-param&gt;<br />
         &lt;init-param&gt;<br />
             &lt;param-name&gt;forceEncoding&lt;/param-name&gt;<br />
             &lt;param-value&gt;true&lt;/param-value&gt;<br />
         &lt;/init-param&gt;<br />
     &lt;/filter&gt;<br />
     &lt;filter-mapping&gt;<br />
         &lt;filter-name&gt;charsetEncoding&lt;/filter-name&gt;<br />
         &lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br />
     &lt;/filter-mapping&gt;

     &lt;!-- spring MVC 配置--&gt;<br />
     &lt;servlet&gt;<br />
          &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
          &lt;servlet-class&gt;org.springframework.web.servlet.DispatcherServlet&lt;/servlet-class&gt;<br />
          &lt;init-param&gt;<br />
             &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
             &lt;!-- 此处指向的的是SpringMVC的配置文件 --&gt;<br />
             &lt;param-value&gt;classpath:spring-mvc.xml&lt;/param-value&gt;<br />
          &lt;/init-param&gt;<br />
          &lt;!--配置容器在启动的时候就加载这个servlet并实例化--&gt;<br />
          &lt;load-on-startup&gt;1&lt;/load-on-startup&gt;<br />
     &lt;/servlet&gt;

     &lt;servlet-mapping&gt;<br />
         &lt;servlet-name&gt;spring&lt;/servlet-name&gt;<br />
         &lt;url-pattern&gt;/&lt;/url-pattern&gt;<br />
     &lt;/servlet-mapping&gt;<br />
     &lt;!-- spring MVC config end--&gt;

     &lt;!-- 加载spring配置文件 --&gt;<br />
     &lt;context-param&gt;<br />
         &lt;param-name&gt;contextConfigLocation&lt;/param-name&gt;<br />
         &lt;param-value&gt;classpath:beans.xml&lt;/param-value&gt;<br />
     &lt;/context-param&gt;<br />
     &lt;!-- listener --&gt;<br />
     &lt;listener&gt;<br />
         &lt;listener-class&gt;org.springframework.web.context.ContextLoaderListener&lt;/listener-class&gt;<br />
     &lt;/listener&gt;

 &lt;/web-app&gt;</pre>
</div>
<p>这就是spring整合hibernate所需要配置的四个文件。文件的加载顺序和包含关系：web.xml&rarr;bans.xml&rarr;datasource.xml&rarr;datasource.properties</p>
<p><strong>注意点</strong>：如果你的配置文件名称和存放位置不同，那么你也需要相应的修改。</p>
<p><strong>注意点</strong>：一定要记得配置事务，否则操作数据库时项目可能不会报错，但数据库中的数据将不会更新（删除或者修改）。具体可以自行百度事务相关的知识。</p>
<p>配置完成后写个例子测试一下。</p>
<p>在model包中创建People.class：</p>
<div>
<pre class="prettyprint linenums"> package com.hcoding.demo.model;

 import java.util.Set;

 import javax.persistence.Column;<br />
 import javax.persistence.Entity;<br />
 import javax.persistence.Id;<br />
 import javax.persistence.Table;<br />
 import javax.persistence.Transient;

 @Entity<br />
 @Table(name="people")<br />
 public class People {

     @Id<br />
     @Column(name="ID")<br />
     private int id;

     @Column(name="name")<br />
     private String name;

     @Column(name="sex")<br />
     private String sex;

     public void setName(String name) {<br />
         this.name = name;<br />
     }<br />
     public String getSex() {<br />
         return sex;<br />
     }<br />
     public void setSex(String sex) {<br />
         this.sex = sex;<br />
     }

 }</pre>
</div>
<p>并在数据库创建people表格，添加相应的字段。</p>
<p>然后在dao包中创建DemoDao.class：</p>
<div>
<div>
<pre class="prettyprint linenums"> package com.hcoding.demo.dao;

 import javax.annotation.Resource;

 import org.hibernate.SessionFactory;<br />
 import org.springframework.stereotype.Repository;

 import com.hcoding.demo.model.People;

 @Repository("demoDao")<br />
 public class DemoDao extends BaseSupportDao{

     @Resource(name="sessionFactory")<br />
     private SessionFactory sessionFactory;

     /**<br />
      * 保存对象<br />
      * @param p<br />
      * @return<br />
      */<br />
     public People save(People p){<br />
         return (People) sessionFactory.getCurrentSession().save(p);<br />
     }

 }</pre>
</div>
<p>在service包中创建DemoServic.class：</p>
<div>
<pre class="prettyprint linenums"> package com.hcoding.demo.service;

 import java.util.HashSet;<br />
 import java.util.Set;

 import javax.annotation.Resource;

 import org.springframework.data.redis.core.RedisTemplate;<br />
 import org.springframework.stereotype.Service;<br />
 import org.springframework.transaction.annotation.Transactional;

 import com.hcoding.demo.dao.DemoDao;<br />
 import com.hcoding.demo.model.Book;<br />
 import com.hcoding.demo.model.People;

 @Service("demoService")<br />
 public class DemoService {

     @Resource(name="demoDao")<br />
     private DemoDao demoDao;;

     @Transactional<br />
     public void save(People p){<br />
        demoDao.save(p);<br />
     }

     public People newPeople(){<br />
         People p=new People();<br />
         p.setName("小白");<br />
         p.setSex("男");<br />
         return p;<br />
     }<br />
  }</pre>
</div>
<p><strong>注意点</strong>：在save方法上加@Transactional注解来开启事务。</p>
<p>在DemoController.class中调用save方法保存数据：</p>
<div>
<pre class="prettyprint linenums"> package com.hcoding.demo.controller;

 import java.util.HashMap;<br />
 import java.util.Map;<br />
 import java.util.concurrent.TimeUnit;

 import javax.annotation.Resource;<br />
 import javax.servlet.http.HttpServletRequest;

 import org.springframework.stereotype.Controller;<br />
 import org.springframework.web.bind.annotation.RequestMapping;<br />
 import org.springframework.web.servlet.ModelAndView;

 import com.alibaba.fastjson.JSON;<br />
 import com.hcoding.demo.model.People;<br />
 import com.hcoding.demo.service.DemoService;

 @Controller<br />
 public class DemoController{

     @Resource(name="demoService")<br />
     private DemoService demoService;

     @RequestMapping("/test")<br />
     public String test(){<br />
         People p=demoService.newPeople();<br />
         demoService.save(p);<br />
         return "test";<br />
     }

 }</pre>
</div>
<p>启动服务器，访问项目。刷新数据库，如果数据保存到数据库中了，说明框架搭建完成。</p>
<h3>6.总结</h3>
<p>以上就是框架整合的全过程，也是自己看了很多教程和自己搭了很多遍后整理的，基本上配置文件是比较整洁，没有多余的内容（因为很容易由于不懂原理，依样画葫芦莫名其妙写了些没有的内容进去），大部分内容也有说明作用，也说了一些需要注意的，我自己犯过错地方。当然，如果你是第一次搭建框架，那么问题远没有那么少，遇到问题就多百度吧，当然，在这之前对于spring框架还是要多了解一点会更利于学习。另外，项目是全注解的，所以对注解不太了解也可以自行百度一下。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq152p29.html">&lpar;转&rpar;Nginx SSL&plus;tomcat集群&comma;request&period;getScheme&lpar;&rpar; 取到https正确的协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/39052yjq.html">zju&lpar;5&rpar;LED控制实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkp259.html">JavaWeb基础&colon; Tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vee6m8.html">iOS - UI - UIStepper</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y55njq.html">gulp之css&comma;js压缩合并加密替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x41kz9.html">java执行命令行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7yg19.html">Android 混淆文件project&period;properties和proguard-project&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdjzv8.html">Node&period;js入门-Node&period;js 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdpywk9.html">返回变量的类型VarType函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k2mr59.html">js 移动端上拉加载下一页通用方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vjym8.html">day4&lpar;while 、练习题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xov0q.html">firewalld</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m25p22q.html">Vue中ESlint配置文件eslintrc&period;js文件详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4zx3e9.html">第2课 类型推导（2）&lowbar;decltype关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyypkd2q.html">SQL SERVER锁（LOCK）知识及锁应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnwz74q.html">Java Queue 专题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e551k9.html">HTML5 的拖放（实例：两个div之间拖放图片）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95357g68.html">java--Struts中请求的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwojzyl9.html">JW Player开始播放和结束播放事件的捕获</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdd1yoq.html">Java数组课程作业</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kp34y59.html">2种方式解决vue路由跳转未匹配相应路由避免出现空白页面或者指定404页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mwn1m8.html">iOS聊天客服功能（Udesk）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1gpdjq.html">curl 支持 http2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp36g39.html">Cocos Creator 监听安卓屏幕下方返回键</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgjpjr8.html">locust压测rpc协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1e37dq.html">C&plus;&plus;模板的要点</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zev4n9.html">C&num;、winform、wpf将类控件放进工具箱里</a>
			</li>
						<li><a href="https://www.batexi.com/a/9505koz8.html">web自动化测试python&plus;selenium学习总结----python环境安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj7g0z8.html">asp&period;net 去掉小数点后面多余的0</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljzr709.html">Unity3D中的shader基础知识</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
